/************************************************************************/
/*                                                                      */
/*   MODULE NAME: ACDICRCV.C                                            */
/*                                                                      */
/*   DESCRIPTIVE NAME: ACDI C SAMPLE RECEIVE PROGRAM                    */
/*                     OS/2 CM/2  Ver 1.2                               */
/*                                                                      */
/*   COPYRIGHT:  (C) COPYRIGHT IBM CORP. 1988, 1991, 1992               */
/*               LICENSED MATERIAL - PROGRAM PROPERTY OF IBM            */
/*               ALL RIGHTS RESERVED                                    */
/*                                                                      */
/*   STATUS:   LPP Release 1.0 Modification 0                           */
/*                                                                      */
/*   FUNCTION: The sample program will use the ACDI interface to echo   */
/*             line by line screen image from the first Personal        */
/*             Computer on the second Personal Computer connected       */
/*             through asynchronous line.                               */
/*             The RECEIVE PROGRAM, is executed in the second Personal  */
/*             Computer.                                                */
/*                                                                      */
/*              Uses the following ACDI Verbs:                          */
/*                                                                      */
/*                COMOPEN                                               */
/*                COMDEFOUTPUTBUFF                                      */
/*                COMDEFINPUT                                           */
/*                COMSETBITRATE                                         */
/*                COMSETLINECTRL                                        */
/*                COMCONNECT                                            */
/*                COMSETTIMEOUTS                                        */
/*                COMREADEVENT                                          */
/*                COMREADCHARSTRING                                     */
/*                COMDISCONNECT                                         */
/*                COMCLOSE                                              */
/*                                                                      */
/*   NOTE:     The asynchronous device name to be used in this          */
/*             program is COM1. If this is to be changed it must        */
/*             be changed in the main header.                           */
/*                                                                      */
/*             This program is designed to run with connect type 4      */
/*             only.                                                    */
/*                                                                      */
/*   MODULE TYPE = IBM CSET/C++ compiler Version 2.00                   */
/*                 noos/sj )                    */
/*                                                                      */
/************************************************************************/

#include "ACDI32_C.H"
#include <STDIO.H>
#include <CONIO.H>
#include <STDDEF.H>
#include <STRING.H>

#define  INCL_BASE

#define INCL_NOBASEAPI
#include <OS2.H>                /* DOS API from Toolkit 2.0                 */
#include <bsedos.h>
#include <bseerr.h>
#include <bsememf.h>



#define MODULE_NAME "ACDI32.DLL"
#define FULL_MODULE_NAME "\\TEST\\ACDI32.dll"


#define PTR16 * _Seg16
#define CALL16 _Far16 _Pascal
#define INT16 short
#define PUSHORT16 unsigned short * _Seg16

#define TRUE 1
#define AA_OK 0

#define LINT_ARGS

#define clear_vcb()   memset(&vcb,0x00,sizeof(vcb))
                                            /* macro to clear control block */
#define STACK_LGTH 8192                     /* len of stack for thread proc */

#define session_active 0
#define session_ended 1

char sys_err       = 0;                     /* system error flag            */
char dev_name[6]   ="COM2\0";               /* communication device name    */

unsigned short handle;                      /* communication device handle  */

unsigned short ret_code;                    /* save area for ACDI return    */
unsigned char func_code;                    /* and function codes           */

unsigned short dos_rc;                      /* save area for dos and        */
unsigned short dos_vio_rc;                  /* vio return codes             */

char *i_anbptr;                             /* pointer to input             */
                                            /* AlphaNumeric buffer          */

char *o_anbptr;                             /* pointer to output            */
                                            /* AlphaNumeric buffer          */

char *s_anbptr;                             /* pointer to stack for the     */
                                            /* thread process-ACDIEVENT     */

char    LoadError[100];
HMODULE ModuleHandle;
APIRET  rc;           /* Return code */


void PTR16 thread_id;                       /* returned by DosCreateThread  */
// int   *thread_id;                       /* returned by DosCreateThread  */
unsigned short us_thread_id;

void PTR16 event_sem;
// ULONG *event_sem;
unsigned long ulevent_sem = 0x00000000;     /* ram semaphore for signaling  */
                                            /* occurance of an event        */

unsigned short concttimeout1 = 0;           /* connection timeout parameters*/
unsigned short concttimeout2 = 30;          /* for comconnect verb          */

unsigned short inf_rdblocktimeout = 0;      /* infinite timeout             */
unsigned short rdchartimeout = 1;           /* parameters for the verb      */
unsigned short inf_wrttimeout = 0;          /* comsettimeouts               */

char ACDIEVENTFLAG;                         /* event occurance flag         */

// extern void CALL16 ACDI(void PTR16);
// extern void ACDI32(PVOID);
extern void ACDI(PVOID);
void ACDIEVENT(void);

/****************************************************************************/
/*  ACDI communications control block                                       */
/****************************************************************************/

union {
   struct comopen_cb open_cb;
   struct comdefinput_cb definputbuff_cb;
   struct comdefoutputbuff_cb defoutputbuff_cb;
   struct comsetbitrate_cb setbitrate_cb;
   struct comsetlinectrl_cb setlinectrl_cb;
   struct comconnect_cb connect_cb;
   struct comsettimeouts_cb settimeouts_cb;
   struct comreadcharstring_cb readcharstring_cb;
   struct comdisconnect_cb disconnect_cb;
   struct comclose_cb close_cb;
}vcb;

void *vcbptr;                              /* pointer to vcb               */

struct event_struct event_types;         /* structures to be used in the */
struct masks event_masks;                /* thread process-acdievent()   */
struct comreadevent_cb readevent_cb;


#ifdef LINT_ARGS
/****************************************************************************/
/*  Function prototypes                                                     */
/****************************************************************************/
// #ifdef __32BIT__
extern USHORT APIENTRY16 Dos16SemWait(ULONG, LONG);
extern USHORT APIENTRY16 Dos16SemSet(ULONG);
// extern USHORT APIENTRY16 Vio16WrtNChar (PCHAR16, USHORT, USHORT, USHORT,
//                                        USHORT);
extern USHORT APIENTRY16 Vio16WrtNChar (char * , USHORT, USHORT, USHORT,
                                        USHORT);

extern USHORT APIENTRY16 Vio16SetCurPos (USHORT, USHORT, USHORT);
extern USHORT APIENTRY16 Vio16ScrollUp (USHORT, USHORT, USHORT, USHORT,
                                        USHORT, char * , USHORT);
extern USHORT APIENTRY16 Vio16GetCurPos (PUSHORT16, PUSHORT16, USHORT);
// #endif
void main(void);
void ACDIREADLINES(void);

void SHOW_ERR(void);
// void SHOW_DOS_ERR(INT16);
void SHOW_DOS_ERR(INT);
void SHOW_VIO_ERR(void);

void set_sem(unsigned long);
void sem_wait(unsigned long);
void clear_screen(void);
//void set_crsr_pos(INT16, INT16);
void set_crsr_pos(int, int);

void comopen(void);
void comdefinput(unsigned short, unsigned char *, unsigned short,
                 unsigned char);
void comdefoutputbuff(unsigned short, unsigned char *, unsigned short);
void comsetbitrate(unsigned short, unsigned short, unsigned short);
void comsetlinectrl(unsigned short, unsigned short, unsigned short,
                    unsigned short);
void comconnect(unsigned short, unsigned short, unsigned short,
                unsigned short);
void comsettimeouts(unsigned short, unsigned short, unsigned short,
                    unsigned short);
void comreadcharstring(unsigned short, unsigned short, unsigned short,
                       unsigned short);
void comreadevent(unsigned short, unsigned long, struct event_struct *,
                  struct masks *, void *);
void comdisconnect(unsigned short);
void comclose(unsigned short);

#endif
/****************************************************************************/
/*   The main program.                                                      */
/****************************************************************************/

void
main(void)
{

  printf("22 ACDI Sample Receive Program.\n");
// rc = DosLoadModule(LoadError,                /* Object name buffer */
//                    sizeof(LoadError),        /* Length of object name
//                                                  buffer */
//                    MODULE_NAME,              /* Module name string */
//                    &ModuleHandle);           /* Module handle */
//
// if (rc != 0)                                 /* Error occurred */
//   {
//    return(rc);
//   }
  event_sem = &ulevent_sem;
  thread_id = &us_thread_id;

  printf("ACDI Sample Receive Program.\n");
  vcbptr = &vcb;                            /* initialize vcbptr            */

  if (! sys_err)
    comopen();                              /* issue com_open verb          */

  if (! sys_err)  {
/**************************************************************************/
/* doscall to get an input buffer.                                        */
/**************************************************************************/
    dos_rc = DosAllocSharedMem((PPVOID)&i_anbptr, (PSZ)NULL, 82,
                                fALLOCSHR);
//                             PAG_COMMIT | PAG_WRITE | OBJ_GIVEABLE |
//                             PAG_GUARD);

    if (dos_rc != 0)  {
      SHOW_DOS_ERR(1);
      sys_err = TRUE;
    }
  }

  if (! sys_err)                            /* issue com_def_input          */
    comdefinput(handle, i_anbptr, 82, AA_CHAR_MODE);

  if (! sys_err)  {
/**************************************************************************/
/* doscall to get an output buffer.                                       */
/**************************************************************************/
    dos_rc = DosAllocSharedMem((PPVOID)&o_anbptr, (PSZ)NULL, 82,
                                fALLOCSHR);
 //                            PAG_COMMIT | PAG_WRITE | OBJ_GIVEABLE |
//                             PAG_GUARD);

    if (dos_rc != 0)  {
      SHOW_DOS_ERR(2);
      sys_err = TRUE;
    }
  }

  if (!sys_err)                             /* issue com_def_output_buff    */
    comdefoutputbuff(handle, o_anbptr, 82);

  if (! sys_err)                            /* issue com_set_bit_rate       */
    comsetbitrate(handle, AA_300_BPS, AA_300_BPS);

  if (! sys_err)                            /* issue com_set_line_ctrl      */
     comsetlinectrl(handle, AA_1_STOP_BIT, AA_EVEN_PARITY, AA_7_DATA_BITS);

  if (! sys_err)                            /* issue com_connect            */
     comconnect(handle,AA_CONNECT_TYPE_4, concttimeout1, concttimeout2);

  if (! sys_err)                            /* issue com_set_timeouts       */
     comsettimeouts(handle, inf_rdblocktimeout, rdchartimeout,
                    inf_wrttimeout);

/**************************************************************************/
/* doscall to start thread procedure.                                     */
/**************************************************************************/
  if (! sys_err)  {
    _beginthread(ACDIEVENT,NULL,8192,NULL);
  }

  if (!sys_err)                             /* call subroutine-read message */
    ACDIREADLINES();

  if (! sys_err)
     comdisconnect(handle);

  if (! sys_err)
     comclose(handle);

}   /* end of main */

/*****************************************************************************/
/*   Thread process                                                          */
/*****************************************************************************/

void ACDIEVENT(void)
/*  This is the thread process. It will set the EVENTFLAG to zero to enable */
/*  receiving characters by the main process, then set the semaphore; issue */
/*  comreadevent verb, and wait for the semaphore to be cleared by async    */
/*  subsystem - which will happen when any one of three events specified -  */
/*  break signal, disconnect or a stop is received. When this occurs it     */
/*  will set the EVENTFLAG to signal end of session.                        */
/*  This process runs asynchronously with the main process so that receiving*/
/*  message, and watching for the break signal can be done simultaneously   */

{
  ACDIEVENTFLAG = session_active;           /* set event flag to active     */

  set_sem((unsigned long)event_sem);        /* set event semaphore          */

  if (! sys_err) {
    event_masks.event_mask_1[0] = 0x00;
    event_masks.event_mask_1[1] = 0x00;
    event_masks.event_mask_1[2] = AA_BREAK_RECEIVED | AA_CONNECTION_LOST;
    event_masks.event_mask_1[3] = AA_STOP_ISSUED;
    event_masks.event_mask_2[0] = 0x00;
    event_masks.event_mask_2[1] = 0x00;
    event_masks.event_mask_2[2] = 0x00;
    event_masks.event_mask_2[3] = 0x00;  /* set up masks for COMREADEVENT*/

    comreadevent(handle,(unsigned long)event_sem, &event_types,
                 &event_masks, &readevent_cb );
                                            /* issue comreadevent verb      */
  }
  if (!sys_err)
    sem_wait((unsigned long)event_sem);    /* wait for sem. to be cleared  */

  if (! sys_err)                            /* semaphore has been cleared so*/
    ACDIEVENTFLAG = session_ended;          /* set flag to session_ended    */
}   /* end of thread process */

/****************************************************************************/
/*  Subroutine to read message.                                             */
/****************************************************************************/

void
ACDIREADLINES()
/* This subroutine will clear the screen in preparation for receiving the   */
/* message, issue com_read_char_string verb as long as ACDIEVENTFLAG is on, */
/* read the message character by character, display it on the screen. It    */
/* will quit when the flag is set to session ended.                         */

{
#define CAR_RET 0x0D                        /* the Enter/Carriage return key*/

unsigned short bytesfreed = 0;              /* parameters for com_read_char_*/
unsigned short readbytesneeded = 1;         /* string verb                  */
unsigned short initialwait = 0;

unsigned short row = 0;                     /* variables to keep track of   */
unsigned short col = 0;                     /* and alter cursor position    */

int ch_atr = 0x720;                         /* parameter for vioscrollup    */
void *ch_atrptr;

  ch_atrptr = &ch_atr;

  clear_screen();                           /* clear the screen             */

  if (!sys_err)
    set_crsr_pos(row, col);                 /* set cursor to row0 column0   */

    while ((ACDIEVENTFLAG == session_active)&&(! sys_err))  {
       comreadcharstring(handle, bytesfreed, readbytesneeded,initialwait);
                                            /* issue com_read_char_string   */

       if (ret_code == 0x54) {
                                            /* if timeout occurred or discon*/
         bytesfreed = 0;                    /* set bytesfreed to zero,      */
         continue;                          /* try to issue verb again      */
       }
       else  {                              /* if no timeout occured and no */
         if (!sys_err)  {                   /* error occured-character has  */
                                            /* been received                */
           i_anbptr = vcb.readcharstring_cb.next_avail_read_ptr;
                                            /* copy ptr to received char.   */
           if (*i_anbptr != CAR_RET)  {     /* if rec'd char is not car_ret */

             dos_vio_rc = Vio16WrtNChar(i_anbptr, 1, row, col, 0);
                                            /* write character on screen    */

             if (dos_vio_rc != 0)  {        /* check viocall return code &  */
               SHOW_VIO_ERR();              /* handle any error             */
               sys_err = TRUE;
             }
             ++col;                         /* incr col-next pos on screen  */
           }
           else  {                          /* otherwise, car_ret was rec'd */
                                            /* it means-start a new line    */
             dos_vio_rc = Vio16GetCurPos(&row, &col, 0) ;
                                            /* doscall-get current crsr pos */

             col = 0;                       /* set column to 0 of next line */
             ++row;                         /* increment current row to next*/
             if (row == 24)  {              /* if current row is 24, scroll */
                                            /* up screen by one row and...  */
               dos_rc = Vio16ScrollUp(0, 0, 24, 79, 1, ch_atrptr,0);

               row = 23;                    /* set current row to 23 again  */
             }
           }
           if (col == 80)                   /* 79th column is last on screen*/
             col = 0;                       /* so if col 79 is reached,     */
                                            /* set it back to zero          */
           set_crsr_pos(row, col) ;         /* set cursor to new position   */
           bytesfreed = 1;                  /* indicate one byte is read    */
         }   /* end of if (! sys_err) */
       }     /* end of else           */
    }        /* end of while loop     */
}            /* end of subroutine     */
/* end of subroutine */

/****************************************************************************/
/*  Utility Functions                                                       */
/****************************************************************************/

void
SHOW_ERR()
/* This function shows errors relating to ACDI verbs.                       */

{
  printf ("ACDI Verb in Error - Function Code = ");
  printf ("%04X\n", func_code);
  printf ("                     Return   Code = ");
  printf ("%04X\n", ret_code);
}

void
// SHOW_DOS_ERR(INT16 n)
SHOW_DOS_ERR(INT n)
/* This function shows errors relating to DOS function calls.               */

{
  printf ("OS/2 Call in Error - Return   Code = ");
  printf ("%04X\n", dos_rc);
  printf ("%02X\n", n);
}

void
SHOW_VIO_ERR()
/* This function shows errors relating to Vio function calls.               */

{
  printf ("Vio  Call in Error - Return   Code = ");
  printf ("%04X\n", dos_vio_rc);
}

/****************************************************************************/
/*  ACDI related subroutines                                                */
/****************************************************************************/

/* To issue an acdi verb the program has to build the control block struc.  */
/* with the parameters and pass the pointer to the control block to the     */
/* acdi subsystem. Each of following subroutines, when called, will build   */
/* the control block structure and then call acdi. When the acdi subsystem  */
/* returns the subroutine will check the return code, call SHOW_ERR process */
/* if the return code is bad, otherwise return to the calling process.      */

void
comopen()
/* This subroutine will issue com_open verb to open the specified com.      */
/* device for communication                                                 */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.open_cb.common.function_code = COM_OPEN;
                                            /* verb - com_open              */
  strcpy(vcb.open_cb.com_dev_name,dev_name);
                                            /* copy communication device    */
                                            /* name into the control block  */
  ACDI(vcbptr);                             /* issue the acdi verb          */
  handle = vcb.open_cb.common.com_dev_handle;
                                            /* copy device handle returned  */
                                            /* by acdi to use in other verbs*/
  if (vcb.open_cb.common.return_code != AA_OK) {
                                            /* check if return code is zero */
                                            /* if not, copy ret & func code */
     ret_code = vcb.open_cb.common.return_code;
     func_code = vcb.open_cb.common.function_code;
     SHOW_ERR();                            /* show error  and              */
     sys_err = TRUE;                        /* set the system error         */
  }
}

void
comdefoutputbuff(unsigned short handle,     /* device handle                */
            unsigned char *outputbuff,      /* pointer to output buffer     */
            unsigned short outbufflength)   /* length of output buffer      */

/* This subroutine will issue com_def_output_buff to define output buffer   */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.defoutputbuff_cb.common.com_dev_handle = handle;
  vcb.defoutputbuff_cb.common.function_code = COM_DEF_OUTPUT_BUFF;
  vcb.defoutputbuff_cb.output_buff = outputbuff;
  vcb.defoutputbuff_cb.out_buff_length = outbufflength;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.defoutputbuff_cb.common.return_code != AA_OK)  {
    ret_code = vcb.defoutputbuff_cb.common.return_code;
    func_code = vcb.defoutputbuff_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comdefinput(unsigned short handle,          /* device handle                */
            unsigned char *inputbuff,       /* pointer to input buffer      */
            unsigned short inbufflength,    /* length of input buffer       */
            unsigned char inputmode)        /* mode of input                */

/* This subroutine will issue com_def_input verb to define input buffer     */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.definputbuff_cb.common.com_dev_handle = handle;
  vcb.definputbuff_cb.common.function_code = COM_DEF_INPUT;
  vcb.definputbuff_cb.input_buff = inputbuff;
  vcb.definputbuff_cb.in_buff_length = inbufflength;
  vcb.definputbuff_cb.input_mode = inputmode;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.definputbuff_cb.common.return_code != AA_OK) {
    ret_code = vcb.definputbuff_cb.common.return_code;
    func_code = vcb.definputbuff_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comsetbitrate(unsigned short handle,        /* device handle                */
              unsigned short rcv_bps,       /* receive data rate            */
              unsigned short trans_bps)     /* transmit data rate           */
/* This subroutine will issue com_set_bit_rate verb to set up the line      */
/* data rates (bps).                                                        */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.setbitrate_cb.common.com_dev_handle = handle;
  vcb.setbitrate_cb.common.function_code = COM_SET_BIT_RATE;
  vcb.setbitrate_cb.bit_rate_rcv = rcv_bps;
  vcb.setbitrate_cb.bit_rate_send = trans_bps;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.setbitrate_cb.common.return_code != AA_OK)  {
    ret_code = vcb.setbitrate_cb.common.return_code;
    func_code = vcb.setbitrate_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comsetlinectrl(unsigned short handle,       /* device handle                */
               unsigned short stopbits,     /* line control parameters      */
               unsigned short par,
               unsigned short databits)
/* This subroutine will issue com_set_line_ctrl to set up line control      */
/* values.                                                                  */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.setlinectrl_cb.common.com_dev_handle = handle;
  vcb.setlinectrl_cb.common.function_code = COM_SET_LINE_CTRL;
  vcb.setlinectrl_cb.stop_bits = stopbits;
  vcb.setlinectrl_cb.parity = par;
  vcb.setlinectrl_cb.data_bits = databits;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.setlinectrl_cb.common.return_code != AA_OK)  {
    ret_code = vcb.setlinectrl_cb.common.return_code;
    func_code = vcb.setlinectrl_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comconnect(unsigned short handle,           /* device handle                */
           unsigned short connecttype,      /* type of connection           */
           unsigned short connecttimeout1,  /* timeout values to set amount */
           unsigned short connecttimeout2)  /* wait time before "hanging up"*/

/* This subroutine will issue com_connect to establish connection           */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.connect_cb.common.com_dev_handle = handle;
  vcb.connect_cb.common.function_code = COM_CONNECT;
  vcb.connect_cb.connect_type = connecttype;
  vcb.connect_cb.connect_timeout_1 = connecttimeout1;
  vcb.connect_cb.connect_timeout_2 = connecttimeout2;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.connect_cb.common.return_code != AA_OK)  {
    ret_code = vcb.connect_cb.common.return_code;
    func_code = vcb.connect_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comsettimeouts(unsigned short handle,       /* device handle                */
               unsigned short rdtimoutblock,/* block mode read timeout      */
               unsigned short rdtimoutchar, /* char mode read timeout       */
               unsigned short wrttimout)    /* write timeout                */

/* This subroutine will issue com_set_timeouts to set the timeout values    */
/* for read and write.                                                      */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.settimeouts_cb.common.com_dev_handle = handle;
  vcb.settimeouts_cb.common.function_code = COM_SET_TIMEOUTS;
  vcb.settimeouts_cb.read_timeout_block = rdtimoutblock;
  vcb.settimeouts_cb.read_timeout_char = rdtimoutchar;
  vcb.settimeouts_cb.write_timeout = wrttimout;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.settimeouts_cb.common.return_code != AA_OK)  {
    ret_code = vcb.settimeouts_cb.common.return_code;
    func_code = vcb.settimeouts_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comreadevent(
unsigned short handle,                      /* device handle                 */
unsigned long semhandle,                    /* sem handle-identifier or addr */
struct event_struct *bufferaddress,       /* event_struct buffer address   */
struct masks *masksaddress,               /* masks structure address       */
void *vcbaddress)                           /* control block address         */

/* This subroutine will issue comreadevent verb so that the calling process */
/* can wait on the semaphore to be cleared.                                 */

{
  readevent_cb.common.com_dev_handle = handle;
  readevent_cb.common.function_code = COM_READ_EVENT;
  readevent_cb.sem_handle = semhandle;
  readevent_cb.buffer_address = bufferaddress;
  readevent_cb.event_masks = masksaddress;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbaddress);                         /* issue the verb               */

  if (readevent_cb.common.return_code != AA_OK) {
    ret_code = readevent_cb.common.return_code;
    func_code = readevent_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comreadcharstring(                          /* device handle                */
unsigned short handle,                      /* num. of bytes read last time */
unsigned short bytesfreed,                  /* return when these many read  */
unsigned short readbytesneeded,             /* bytes are available          */
unsigned short initialwait)                 /* initial delay for timeout    */

/* This subroutine will issue com_read_char_string verb to enable program   */
/* to read data that has been received over the line and is put in the      */
/* input buffer.                                                            */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.readcharstring_cb.common.com_dev_handle = handle;
  vcb.readcharstring_cb.common.function_code = COM_READ_CHAR_STRING;
  vcb.readcharstring_cb.bytes_freed = bytesfreed;
  vcb.readcharstring_cb.read_bytes_needed = readbytesneeded;
  vcb.readcharstring_cb.initial_wait = initialwait;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */


  if (vcb.readcharstring_cb.common.return_code != AA_OK) {
                                            /* if return is not good....    */
    ret_code = vcb.readcharstring_cb.common.return_code;
    func_code = vcb.readcharstring_cb.common.function_code;
                                            /* copy return and func. codes  */
    if ( ret_code == 0x54)                  /* if ret_code is 54H - timeout */
      return;                               /* occured - just return        */
    else {                                  /* otherwise an error occured - */
      SHOW_ERR();                           /* so handle the error          */
      sys_err = TRUE;
      return;
    }
  }
  else                                      /* if return is good - data is  */
    ret_code = AA_OK;                       /* received; set ret_code to ok */
}

void
comdisconnect(unsigned short handle)        /* device handle                */
/* This subroutine will issue com_disconnect to break the connection.       */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.disconnect_cb.common.com_dev_handle = handle;
  vcb.disconnect_cb.common.function_code = COM_DISCONNECT;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */


  if (vcb.disconnect_cb.common.return_code != AA_OK)  {
    ret_code = vcb.disconnect_cb.common.return_code;
    func_code = vcb.disconnect_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

void
comclose(unsigned short handle)             /* device handle                */
/* This subroutine will issue com_close to close the communication device.  */

{
  clear_vcb();                              /* zero out the control block   */

  vcb.close_cb.common.com_dev_handle = handle;
  vcb.close_cb.common.function_code = COM_CLOSE;
                                            /* fill in control block with   */
                                            /* function code and parameters */
  ACDI(vcbptr);                             /* issue the verb               */

  if (vcb.close_cb.common.return_code != AA_OK)  {
    ret_code = vcb.close_cb.common.return_code;
    func_code = vcb.close_cb.common.function_code;
    SHOW_ERR();
    sys_err = TRUE;                         /* check return code and handle */
                                            /* any errors                   */
  }
}

/*****************************************************************************/
/*  OS/2 Related Functions                                                   */
/*****************************************************************************/

void
set_sem(unsigned long sem_handle)
/* This function sets semaphore.                                             */

{
  dos_rc = Dos16SemSet(sem_handle);

  if (dos_rc != AA_OK) {
    SHOW_DOS_ERR(5);
    sys_err = TRUE;
  }
}

void
sem_wait(unsigned long sem_handle)
/* This function waits till the semaphore is cleared.                       */

{
long inf_wait_timeout = -1;                 /* cause thread to be blocked   */
                                            /* indef. till sem. is cleared  */
  dos_rc = Dos16SemWait(sem_handle,inf_wait_timeout);

  if (dos_rc != AA_OK) {
    SHOW_DOS_ERR(6);
    sys_err = TRUE;
  }
}

void
clear_screen()
/* This function clears the screen to prepare to display message received.   */
/* Writes null on the whole screen                                           */

{
#define SCREENSIZE 2000

char null = 0x20;

  dos_vio_rc = Vio16WrtNChar (&null, SCREENSIZE, 0, 0, 0);
                                            /* vio call to write on screen  */
  if (dos_vio_rc != 0)  {
    SHOW_VIO_ERR();
    sys_err = TRUE;
  }                                         /* handle any error             */
}

void
// set_crsr_pos(INT16 row_no, INT16 col_no)
set_crsr_pos(int row_no, int col_no)
/* This function sets the cursor position at the specified row and column.  */

{
  dos_vio_rc = Vio16SetCurPos(row_no, col_no,0);
                                            /* vio call to set cursor pos   */
  if (dos_vio_rc != 0)  {
    SHOW_VIO_ERR();
    sys_err = TRUE;                         /* handle any error             */
  }
}

